Index: Dev/trunk/Gruntfile.js
===================================================================
--- Dev/trunk/Gruntfile.js	(revision 516)
+++ Dev/trunk/Gruntfile.js	(revision 517)
@@ -8,6 +8,9 @@
     // TASKS
 
+    // default task
     grunt.registerTask('default', ['compile']);
-    grunt.registerTask('compile', ['svn-ignore:compile'
+    // development
+    grunt.registerTask('compile', ['path-check:svn'
+                                  ,'svn-ignore:compile'
                                   ,'jshint:lint-sources'
                                   ,'htmlhint:lint'
@@ -22,4 +25,7 @@
                                 //,'amd-check' // too smart about plugins, r.js can't find them
                                   ]);
+    grunt.registerTask('run', ['path-check:foreman'
+                              ,'compile'
+                              ,'foreman:dev']);
     grunt.registerTask('build', ['compile'
                                 ,'clean:build'
@@ -27,8 +33,25 @@
                                 ,'dojo:build'
                                 ]);
-    grunt.registerTask('deploy', ['path-check:deploy',
-                                  'svninfo',
-                                  'build',
-                                  'git_deploy:deploy']);
+    grunt.registerTask('run-build', ['path-check:foreman'
+                                    ,'build'
+                                    ,'foreman:build']);
+    grunt.registerTask('deploy', ['path-check:svn'
+                                 ,'path-check:git'
+                                 ,'svninfo'
+                                 ,'build'
+                                 ,'git_deploy:deploy']);
+    // database management
+    grunt.registerTask('db-backup-cloud-to-dated-local',
+                       ['path-check:heroku'
+                       ,'heroku-config'
+                       ,'http:db-backup-cloud-to-dated-local']);
+    grunt.registerTask('db-pull-cloud-to-local',
+                       ['path-check:heroku'
+                       ,'heroku-config'
+                       ,'http:db-pull-cloud-to-local']);
+    grunt.registerTask('db-push-local-to-cloud',
+                       ['path-check:heroku'
+                       ,'heroku-config'
+                       ,'http:db-push-local-to-cloud']);
 
     // FILES AND FOLDERS
@@ -46,6 +69,9 @@
 
     // TASK CONFIG
-    
+
     grunt.initConfig({
+        localDbURL: "http://localhost:5984",
+        timestamp: "<%= grunt.template.today(\"UTC:yyyymmdd't'HHMMss'z'\") %>",
+
         'amd-check': {
             files: [ srcDir+'client/qed-client/**/*.js' ]
@@ -73,4 +99,16 @@
                                 releaseDir: '../../'+buildDir }}
         },
+        foreman: {
+            dev: {
+                options: {
+                    cwd: srcDir
+                }
+            },
+            build: {
+                options: {
+                    cwd: buildDir
+                }
+            }
+        },
         git_deploy: {
             deploy: {
@@ -83,4 +121,10 @@
             }
         },
+        'heroku-config': {
+            options: {
+                app: 'quod-erat',
+                keys: ['CLOUDANT_URL']
+            }
+        },
         htmlhint: {
             options: { htmlhintrc: srcDir+".htmlhintrc" },
@@ -89,4 +133,40 @@
                               src: ['client/*.html', 'client/qed-client/**/*.html'] }]}
         },
+        http: {
+            'db-backup-cloud-to-dated-local': {
+                options: {
+                    url: "<%= localDbURL %>/_replicate",
+                    method: 'POST',
+                    body: {
+                        source: "<%= herokuConfig.CLOUDANT_URL %>/qed",
+                        target: "qed-<%= timestamp %>",
+                        create_target: true
+                    },
+                    json: true
+                }
+            },
+            'db-pull-cloud-to-local': {
+                options: {
+                    url: "<%= localDbURL %>/_replicate",
+                    method: 'POST',
+                    body: {
+                        source: "<%= herokuConfig.CLOUDANT_URL %>/qed",
+                        target: "qed"
+                    },
+                    json: true
+                }
+            },
+            'db-push-local-to-cloud': {
+                options: {
+                    url: "<%= localDbURL %>/_replicate",
+                    method: 'POST',
+                    body: {
+                        source: "qed",
+                        target: "<%= herokuConfig.CLOUDANT_URL %>/qed"
+                    },
+                    json: true
+                }
+            }
+        },
         jshint: {
             'lint-sources': { options: { jshintrc: srcDir+".jshintrc" },
@@ -104,6 +184,15 @@
         },
         'path-check': {
-            'deploy': {
-                src: [ 'git', 'svn' ]
+            'heroku': {
+                src: ['heroku']
+            },
+            'foreman': {
+                src: ['foreman']
+            },
+            'svn': {
+                src: ['svn']
+            },
+            'git': {
+                src: ['git']
             }
         },
@@ -164,4 +253,5 @@
     grunt.loadNpmTasks('grunt-git-deploy');
     grunt.loadNpmTasks('grunt-htmlhint');
+    grunt.loadNpmTasks('grunt-http');
     grunt.loadNpmTasks('grunt-jsonlint');
     grunt.loadNpmTasks('grunt-path-check');
Index: Dev/trunk/grunt-tasks/heroku.js
===================================================================
--- Dev/trunk/grunt-tasks/heroku.js	(revision 517)
+++ Dev/trunk/grunt-tasks/heroku.js	(revision 517)
@@ -0,0 +1,75 @@
+var _ = require('underscore')
+  , path = require('path');
+
+module.exports = function(grunt) {
+    
+    grunt.registerTask(
+        'heroku-config',
+        "Get config values from heroku app and put them in grunt.config.",
+        function(){
+            var done = this.async();
+            var options = this.options({
+                keys: [],
+                output: 'herokuConfig'
+            });
+            if ( !options.app ) {
+                done(new Error(("Must specify the app name.")));
+            } else {
+                if ( options.keys.length === 0 ) {
+                    grunt.log.warn("Did not specify any config keys.");
+                }
+                var tasks = _.map(options.keys, function(key){
+                    return _.partial(getConfigValue,options.app,key);
+                });
+                grunt.util.async.series(tasks,function(error,results){
+                    if ( error ) {
+                        done(error);
+                    } else {
+                        var herokuConfig = {};
+                        _.each(results,function(result){
+                            _.extend(herokuConfig,result);
+                        });
+                        grunt.config.set(options.output,herokuConfig);
+                        done();
+                    }
+                });
+            }
+        });
+
+    function getConfigValue(app,key,callback) {
+        grunt.util.spawn({
+            cmd: 'heroku',
+            args: ['config:get',key,'--app',app]
+        }, function(error,result){
+            if ( error ) {
+                callback(error);
+            } else {
+                var value = grunt.util.normalizelf(result.stdout)
+                            .split(grunt.util.linefeed)[0];
+                result = {};
+                result[key] = value;
+                callback(null,result);
+            }
+        });
+    }
+
+    grunt.registerMultiTask(
+        'foreman',
+        "Run a foreman command in a directory.",
+        function(){
+            var options = this.options({
+                cmd: 'start',
+                cwd: '.'
+            });
+            var done = this.async();
+            grunt.util.spawn({
+                cmd: 'foreman',
+                args: [options.cmd],
+                opts: {
+                    cwd: options.cwd,
+                    stdio: 'inherit'
+                }
+            }, done);
+        });
+
+};
Index: Dev/trunk/grunt-tasks/svn-ignore.js
===================================================================
--- Dev/trunk/grunt-tasks/svn-ignore.js	(revision 516)
+++ Dev/trunk/grunt-tasks/svn-ignore.js	(revision 517)
@@ -6,41 +6,43 @@
 module.exports = function(grunt) {
 
-    grunt.registerMultiTask('svn-ignore',
-                            "Makes sure the specified source files are ignored in Subversion.",
-                            function(){
-        var done = this.async();
+    grunt.registerMultiTask(
+        'svn-ignore',
+        "Makes sure the specified source files are ignored in Subversion.",
+        function(){
+            var done = this.async();
 
-        var tasks = _.chain(this.filesSrc)
-                     .groupBy(path.dirname)
-                     .map(function(files, dir) {
-                         return _.partial(updateSvnIgnore,
-                                          dir,
-                                          _.chain(files)
-                                           .map(path.basename)
-                                           .sortBy(_.identity)
-                                           .value());
-                     })
-                     .value();
+            var tasks = _.chain(this.filesSrc)
+                         .groupBy(path.dirname)
+                         .map(function(files, dir) {
+                             return _.partial(updateSvnIgnore,
+                                              dir,
+                                              _.chain(files)
+                                               .map(path.basename)
+                                               .sortBy(_.identity)
+                                               .value());
+                         })
+                         .value();
 
-        grunt.util.async.series(tasks,function(error, results){
-            done(error);
+            grunt.util.async.series(tasks,function(error, results){
+                done(error);
+            });
         });
-    });
 
-    grunt.registerMultiTask('svn-ignore-clean',
-                            "Clean generated ignore sections in Subversion.",
-                            function(){
-        var done = this.async();
+    grunt.registerMultiTask(
+        'svn-ignore-clean',
+        "Clean generated ignore sections in Subversion.",
+        function(){
+            var done = this.async();
 
-        var tasks = _.chain(this.filesSrc)
-                     .map(function(file) {
-                         return _.partial(clearSvnIgnore, file);
-                     })
-                     .value();
+            var tasks = _.chain(this.filesSrc)
+                         .map(function(file) {
+                             return _.partial(clearSvnIgnore, file);
+                         })
+                         .value();
 
-        grunt.util.async.series(tasks,function(error, results){
-            done(error);
+            grunt.util.async.series(tasks,function(error, results){
+                done(error);
+            });
         });
-    });
 
     function updateSvnIgnore(dir,files,callback) {
@@ -123,31 +125,28 @@
     
     function readSvnIgnore(dir,callback) {
-        return svnCommand('svn',
-                          ['propget', 'svn:ignore', dir],
-                          callback);
+        return svn(['propget', 'svn:ignore', dir],
+                   callback);
     }
 
     function writeSvnIgnore(dir,ignore,callback) {
-        return svnCommand('svn',
-                          ['propset', 'svn:ignore', ignore, dir],
-                          callback);
+        return svn(['propset', 'svn:ignore', ignore, dir],
+                   callback);
     }
     
     function deleteSvnIgnore(dir,callback) {
-        return svnCommand('svn',
-                          ['propdel', 'svn:ignore', dir],
-                          callback);
+        return svn(['propdel', 'svn:ignore', dir],
+                   callback);
     }
     
-    function svnCommand(cmd,args,callback) {
+    function svn(args,callback) {
         grunt.util.spawn({
-            cmd: cmd,
+            cmd: 'svn',
             args: (args || [])
-        }, function(error, result, code) {
+        }, function(error, result) {
             if ( error ) {
                 callback(error);
-                return;
+            } else {
+                callback(null,result.stdout);
             }
-            callback(null,result.stdout);
         });
     }
